//==============================================================================
//
// Zap I/O WDM Device Driver
//
// nt ȯ濡 I/O Ʈ ׼   ִ  ϴ ̹ Դϴ.
//
//  -  : 2003 1 4
//  -  : 
//  - ̸ : AlphaMCU@hanmail.net
//  - ּ : http://www.zap.pe.kr
//
//  - Copyright (C) 2002~2003 Kyung-Ryul Sun.
//
//==============================================================================

#ifdef __cplusplus
extern "C" {
#endif

#define INITGUID

#include "wdm.h"
#include "deviceinterface.h"


//==============================================================================
//
// Device Extension 
//
//==============================================================================
#define	IOPM_SIZE	0x2000
typedef UCHAR IOPM[IOPM_SIZE];

typedef struct {
	PDEVICE_OBJECT	pPdo;				// Physical Device Object
	PDEVICE_OBJECT	pNextDevObj;		// Next Lower Device Object
	UNICODE_STRING	SymLinkName;		// Symbolic Link Name
	IOPM			*m_pIOPL;			// I/O Port Map
} DEVICE_EXTENSION, *PDEVICE_EXTENSION;


//==============================================================================
//
// ܺο  Լ 
//
//==============================================================================
NTSTATUS DriverEntry (IN PDRIVER_OBJECT, IN PUNICODE_STRING);
NTSTATUS Entry_Unload(IN PDRIVER_OBJECT);

NTSTATUS Entry_AddDevice(IN PDRIVER_OBJECT, IN PDEVICE_OBJECT);

NTSTATUS Entry_DispatchPnp		(IN PDEVICE_OBJECT, IN PIRP);
NTSTATUS Entry_DispatchPower	(IN PDEVICE_OBJECT, IN PIRP);

NTSTATUS Entry_DispatchCreate	(IN PDEVICE_OBJECT, IN PIRP);
NTSTATUS Entry_DispatchClose	(IN PDEVICE_OBJECT, IN PIRP);


//
#ifdef __cplusplus
}
#endif
